﻿@page "/uncertain-phrases/create"
@page "/uncertain-phrases/{Id:int}/edit"
@using Syncfusion.Blazor.DropDowns

<PageTitle>JWobot Admin | Uncertain Phrase Form</PageTitle>
<div class="d-sm-flex align-items-center justify-content-between mb-4">
    <h1 class="h3 mb-0 text-gray-800">Uncertain Phrase Form</h1>
</div>


<div class="card shadow mb-4">
    <div class="card-body">
        <EditForm Model="@upModel" OnValidSubmit="@HandleValidSubmit" OnInvalidSubmit="@HandleInvalidSubmit">
            <DataAnnotationsValidator />
            <ValidationSummary />
            <div class="row">
                <div class="col-md-12 mb-3">
                    <div class="form-group">
                        <label>Phrase</label>
                        <InputText @bind-Value="upModel.Phrase" class="form-control" />
                    </div>
                </div>
            </div>
            <div class="form-group mt-3">
                @if (Id.HasValue)
                {
                    <button type="button" class="btn btn-danger" @onclick="Delete">Delete</button>
                }
                <button type="submit" class="btn btn-primary float-right">Save</button>
            </div>
        </EditForm>
    </div>
</div>

@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationStateTask { get; set; }
    private string email;

    [Parameter]
    public int? Id { get; set; }
    private bool isSaving = false;

    private UncertainPhraseModel upModel = new UncertainPhraseModel();
    public string pageTitle = "Create Uncertain Phrase";

    protected async override Task OnInitializedAsync()
    {
        await JS.ShowLoader();
        var claimsPrincipal = (await authenticationStateTask).User;
        email = ((CustomAuthenticationStateProvider)AuthenticationStateProvider).GetCurrentUserEmail(claimsPrincipal);

        if (Id.HasValue)
        {
            pageTitle = "Update Uncertain Phrase";
            upModel = Mapper.Map<UncertainPhraseModel>(UncertainPhraseService.GetById(Id.Value));
        }
        await JS.HideLoader();

    }

    protected async Task HandleInvalidSubmit()
    {
        await JS.ShowError(pageTitle, "Please complete all requried fields");
    }

    private async Task HandleValidSubmit()
    {
        if (!isSaving)
        {
            isSaving = true;
            await JS.ShowLoader();
            try
            {
                var up = Mapper.Map<UncertainPhrase>(upModel);
                var action = "created";
                if (Id.HasValue)
                {
                    action = "updated";
                    up.Id = Id.Value;
                    up.ModifiedBy = email;
                    await UncertainPhraseService.Update(up);
                }
                else
                {
                    up.CreatedBy = email;
                    await UncertainPhraseService.Create(up);
                }
                await JS.ShowSuccess(pageTitle, $"Uncertain Phrase successfully {action}");
                Navigation.NavigateTo("/uncertain-phrases");
            }
            catch (Exception ex)
            {
                await JS.ShowError(pageTitle, ex.Message.ToString());
            }

            await JS.HideLoader();
            isSaving = false;
        }
    }

    private async Task Delete()
    {
        await UncertainPhraseService.Delete(Id.Value);
        await JS.ShowSuccess(pageTitle, $"Uncertain Phrase successfully deleted");
        Navigation.NavigateTo("/uncertain-phrases");
    }
}
